#ifndef gnome_func_hint_h
#define gnome_func_hint_h

#include <gtk/gtk.h>

#define XA_WIN_SIGNAL_FUNC_HINT "_WIN_SIGNAL_FUNC_HINT"
#define XA_WIN_SIGNAL_FUNC_HINT_BACK "_WIN_SIGNAL_FUNC_HINT_BACK"

/* the structure which is passed to the listener */
typedef struct _GnomeSignalFuncListener
{
  gchar         *strtitel; /* name of the function */ 
  GtkSignalFunc  func;     /* the callback function */
  gint           xwindow;  /* the xwindow id */
  gint32         key;      /* the shared memory key */
  gpointer       data;     /* the user data */
}GnomeSignalFuncListener;

/* it's not neccessary to call this function explicit */
void gnome_signal_func_hint_init();

/* this function uses the client */
gboolean gnome_signal_func_hint_set( GtkWidget *widget, /* the own widget (should be a toplevel window) */
				     gchar* name,       /* a string which is passed to the listener */
				     GtkSignalFunc func, /* the callbackfunction for getting signals from the listener */
				     gpointer data );    /* userdata */

/* this function uses the listener */
gboolean gnome_signal_func_hint_get( GtkSignalFunc func, /* callback function for listen to clients */
				     GtkWidget *widget,  /* the own widget (should be a toplevel window) */
				     gpointer data );    /* userdata */

/* free all */
void gnome_signal_func_hint_quit();

#endif
