#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdlib.h>
#include <time.h>
#include "sharedm.h"

#define MAX_NUM  (214748364 -1) /* max random number */

gint32 get_new_key();

static int was_init = FALSE;

void gnome_shared_mem_init()
{
  srand( time(NULL) ); /* initialize the random number generator */
  was_init = TRUE;
}

gint32 gnome_shared_mem_write( gpointer data, gulong size )
{
  key_t key;
  int shmid, cntr;
  char *segptr;
  char *ptr;

  if( was_init == FALSE )
    gnome_shared_mem_init();

  /* open a new shared memory */
  do{
    key = get_new_key();
/*    g_print( "%d\n", key ); */
  } while((shmid = shmget( key, size, IPC_CREAT|IPC_EXCL|0666)) == -1 );
  
  if((int) (segptr = shmat( shmid, 0, 0)) == -1 )
    g_error("shmat");

  /* copy the data into the shared memory */
  g_memdup( data, size ); 
  g_memmove( segptr, data, size );

  return (gint32) key;
}

gint32 get_new_key()
{
  gint32 j;

  j= 1+(int) ( (float)(MAX_NUM) *rand()/(RAND_MAX+1.0));

  return j;
}

gpointer gnome_shared_mem_read( gint key, gulong size )
{
  int shmid;
  char* segptr;

  if(( shmid = shmget( (key_t) key, size, 0)) == -1)
    return NULL;

  if((int) (segptr = shmat( shmid, 0, 0)) == -1 )
    return NULL;
  
  return g_memdup( segptr, size );
}

void gnome_shared_mem_free( gint key )
{
  int shmid;

  if(( shmid = shmget( (key_t) key, 0, 0)) == -1)
    return;
  
  shmctl( shmid, IPC_RMID, 0 );
}
