#include <gnome.h>
#include "gnome_func_hint.h"

static void quit( GtkWidget *widget, gpointer data )
{
  /* free all */
  gnome_signal_func_hint_quit();
  gtk_main_quit();
}

static void message( GtkWidget *widget, gpointer data )
{
  static GtkWidget *vbox = NULL;
  GtkWidget *label;
  gchar* string;

  /* g_message( "The application got a message!: %s", (gchar*) data); */

  if( vbox == NULL )
    {
      vbox = gtk_vbox_new( TRUE, 0 );
      gnome_app_set_contents( GNOME_APP( widget ), vbox );
      gtk_widget_show( vbox );
    }
  string = g_strconcat( "The application got a message: ", (gchar*) data, NULL );
  label = gtk_label_new( string );
  g_free( string );
  gtk_widget_show( label );
  gtk_box_pack_start_defaults( GTK_BOX( vbox ), label );
}

int main( int argc, char **argv )
{
  GtkWidget *app;

  gnome_init( "testclient", "0.0.1", argc, argv );

  app = gnome_app_new( "testclient", "Testclient" );
  gtk_signal_connect( GTK_OBJECT( app ), "destroy",
		      GTK_SIGNAL_FUNC( quit ), NULL );
  gtk_widget_set_usize( app , 300 , 100);
  gtk_widget_show( app );

  /* registering the callback functions */
  gnome_signal_func_hint_set( app, "Message1", message, "Hello World" );
  gnome_signal_func_hint_set( app, "Message2", message, "Hello Moon" ); 

  gtk_main();

  return 0;
}

