#include <gnome.h>
#include <stdio.h>

#include "gnome_func_hint.h" 

static void quit( GtkWidget *w, gpointer data )
{
  gnome_signal_func_hint_quit(); /* free the memory */
  gtk_main_quit();
}

/* the function which listens to the client messages */
static void listen( GtkWidget *widget, /* the own widget */
		    gpointer data )    /* a pointer on a GnomeSignalFuncListener structure */
{
  static GtkWidget *vbox= (GtkWidget*) NULL;
  GtkWidget *button;
  GnomeSignalFuncListener *listen;
  char *string;

  listen = (GnomeSignalFuncListener*) data;

  if( vbox == NULL)
    {
      vbox =  gtk_vbox_new( TRUE, 0 );
      gnome_app_set_contents( GNOME_APP( widget ), vbox );
      gtk_widget_show( vbox );
    }
  string  = g_strdup_printf( "%s from xwindow %d", listen->strtitel, listen->xwindow );
  button = gtk_button_new_with_label( string ); 
  g_free( string );
  gtk_widget_show( button );
  gtk_box_pack_start_defaults( GTK_BOX( vbox ), button );
  gtk_signal_connect( GTK_OBJECT( button ), "pressed",
		      listen->func, /* the callback function */ 
		      listen );     /* the pointer on the GnomeSignalFuncListener structure.
				     * you have to pass it through  !!!!! */
}

int main( int argc, char **argv )
{
  GtkWidget *app;

  gnome_init( "testlistener", "0.0.1", argc, argv );

  app = gnome_app_new( "testlistener", "Testlistener" );
  gtk_signal_connect( GTK_OBJECT( app ), "destroy",
		      GTK_SIGNAL_FUNC( quit ), NULL );
  gtk_widget_set_usize( app , 300 , 200);
  gtk_widget_show( app );

  /* registering the listen function */
  gnome_signal_func_hint_get( listen, app, NULL );

  gtk_main();

  return 0;
}
